/* Common include files. 
   The source code may be redistributed, as long it remains intact, and
   with this License included. You may modify or use this source code in
   anyway you see fit, but credit must be given where applicable.

   This software comes with NO warranty, and the author is NOT liable for
   any damages which may come from the use of this software.

  You may not use the name of the author to promote this software.

  shadows@whitefang.com (Thamer Al-Herbish)
*/

#include <stdio.h>
#include <stdlib.h>

#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>

#include <string.h>
#include <pcap.h>

#include <netinet/in_systm.h>
#include <net/if.h>
#include <netinet/ip.h>
#include <netinet/tcp.h>
#include <netinet/if_ether.h>

#include <unistd.h>
#include <signal.h>
#include <errno.h>

#ifndef ETHER_ADDR_LEN
#define ETHER_ADDR_LEN 6
#endif
#ifndef ETHER_HDR_LEN
#define ETHER_HDR_LEN (sizeof(struct ether_header))
#endif

struct con {
  int have;
  unsigned long ack;
  unsigned char state; /* The state of the connection */

  struct in_addr src;  /* Host initiating connection. */
  struct in_addr dst;  /* Listening host. */

  unsigned short sport; /* Source port on initiating host. */
  unsigned short dport; /* Destination port on listening host */

  unsigned char mac_src[ETHER_ADDR_LEN];  /* MAC of initiating host. */
  unsigned char mac_dest[ETHER_ADDR_LEN]; /* MAC of destitination host. */
  struct timeval timestamp; /* Timestamp of last packet sent. */
  unsigned char flags;
  struct con *next;
};

#define ETHERBUFF 88
#define PPPBUFF (sizeof(struct ppp_header)+sizeof(struct ip)+sizeof(struct tcphdr))
#define IPSIZE 16

#define MAC_SIZE (ETHER_ADDR_LEN * 3)

#define PORTSIZE 6

/* States. */

#define SYN_SENT 1
#define SYN_RECV 2
#define DONE     3     /* Never actually used. */
#define SYN_SCAN 4      /* Possible syn scan attempt */
